Rank
一般
A. 网络
签不上的签到题。
首先考虑枚举路径的做法,如果先枚举再计算的话复杂度会是 \(\mathcal{O(\binom{n+m-2}{n-1}(n+m))}\) 的,稍微优化一点的过程中可以去掉后面的 \((n+m)\)。考虑此时我们要记什么,首先遇到加号其前面的值 \(z\) 就确定了,若上个符号为乘号那么需记录乘数 \(x\),同时显然还需记录当前的数 \(y\),可以得到 30pts。
迁移到 \(\mathcal{O(nm)}\) 的做法上,稍微改变一些定义,将记当前的数直接改为记当前的数与所记乘数的积。分讨三种转移:
- 若当前位置为数字:\(y\leftarrow 10x+x\cdot a_{i,j}\)
- 若当前位置为乘号:\(x\leftarrow y,\ y\leftarrow 0\)
- 若当前位置为加号:\(z\leftarrow y+z,\ y\leftarrow 0,\ x\leftarrow 1\)
发现这样转移仍然是针对一个表达式的,优化也很简单,提前处理可能的 \(x\) 值,即到这个点一共有几种可能。感性理解就是:在这个点一共会进行棘刺这样的转移。然后就做完了,复杂度 \(\mathcal{O(nm)}\)。
点击查看代码
#include<bits/stdc++.h>
#define fo(x, y, z) for(register int (x) = (y); (x) <= (z); (x)++)
#define fu(x, y, z) for(register int (x) = (y); (x) >= (z); (x)--)
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
#define lx ll
inline lx qr()
{char ch = getchar(); lx x = 0, f = 1;for(; ch < '0' || ch > '9'; ch = getchar()) if(ch == '-') f = -1;for(; ch >= '0' && ch <= '9'; ch = getchar()) x = (x << 3) + (x << 1) + (ch ^ 48);return x * f;
}
#undef lx
#define qr qr()
#define fi first
#define se second
#define pii pair<int, int>
#define P_B(x) push_back(x)
#define M_P(x, y) make_pair(x, y)
const int Ratio = 0;
const int N = 2000 + 5;
const int mod = 998244353;
int n, m;
string s[N];
ll z[N][N], x[N][N], y[N][N], zc[N][N];
namespace Wisadel
{short main(){freopen("grid.in", "r", stdin), freopen("grid.out", "w", stdout);n = qr, m = qr;fo(i, 1, n) cin >> s[i], s[i] = " " + s[i];zc[1][0] = 1;x[1][0] = 1;fo(i, 1, n) fo(j, 1, m){x[i][j] = (x[i - 1][j] + x[i][j - 1]) % mod;y[i][j] = (y[i - 1][j] + y[i][j - 1]) % mod;z[i][j] = (z[i - 1][j] + z[i][j - 1]) % mod;zc[i][j] = (zc[i - 1][j] + zc[i][j - 1]) % mod;if(s[i][j] == '+'){z[i][j] = (z[i][j] + y[i][j]) % mod;x[i][j] = zc[i][j];y[i][j] = 0;}else if(s[i][j] == '*'){x[i][j] = y[i][j];y[i][j] = 0;}else y[i][j] = (y[i][j] * 10 % mod + (s[i][j] - '0') * x[i][j] % mod) % mod;}printf("%lld\n", (z[n][m] + y[n][m]) % mod);return Ratio;}
}
signed main(){return Wisadel::main();}
B. 矩形
正解是根号分治。不是很会,于是在 GGrun 的帮助下焯过去了。
思路很平凡,将同一列和同一行的点通过排序处理出来,然后看列数和行数哪个少用哪个。求答案时朴素实现是枚举两列,双指针移动找匹配段,记录总数 \(x\),贡献为 \(\frac{x(x-1)}{2}\),统计答案即可。
发现会 TLE,于是考虑少些无用的枚举。我们只枚举一列,然后枚举列上面的每个点,再枚举该点所在行上的点,更新这些点所在列的贡献。发现 \(\frac{x(x-1)}{2}\) 可以拆成 \(\frac{x^2}{2}-\frac{x}{2}\),根据转移式 \((x+1)^2=x^2+2x+1\) 可以递推出总贡献,最后再枚举列统计贡献即可,然后就过了,复杂度 \(\mathcal{O(能过)}\)。(我的实现常数过大会被卡
焯代码
#include<bits/stdc++.h>
#define fo(x, y, z) for(register int (x) = (y); (x) <= (z); (x)++)
#define fu(x, y, z) for(register int (x) = (y); (x) >= (z); (x)--)
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
#define lx ll
inline lx qr()
{char ch = getchar(); lx x = 0, f = 1;for(; ch < '0' || ch > '9'; ch = getchar()) if(ch == '-') f = -1;for(; ch >= '0' && ch <= '9'; ch = getchar()) x = (x << 3) + (x << 1) + (ch ^ 48);return x * f;
}
#undef lx
#define qr qr()
#define fi first
#define se second
#define pii pair<int, int>
#define P_B(x) push_back(x)
#define M_P(x, y) make_pair(x, y)
const int Ratio = 0;
const int N = 2e5 + 5;
const int mod = 998244353;
int n, tot;
int prex[N], prey[N];
ll sum[N], ans, ans1[N], ans2[N];
struct rmm
{int x, y;bool operator < (const rmm &A) const{return y == A.y ? x < A.x : y < A.y;}
} d[N], p[N];
pii xx[N], yy[N];
namespace Wisadel
{bool cmpn(rmm A, rmm B){return A.x == B.x ? A.y < B.y : A.x < B.x;}bool cmpm(rmm A, rmm B){return A.y == B.y ? A.x < B.x : A.y < B.y;}short main(){freopen("rect.in", "r", stdin), freopen("rect.out", "w", stdout);n = qr;ll c = 1;fo(i, 2, n) sum[i] = sum[i - 1] + c, c++;fo(i, 1, n) d[i].x = p[i].x = qr, d[i].y = p[i].y = qr;sort(d + 1, d + 1 + n, cmpn);sort(p + 1, p + 1 + n, cmpm);int zoz = 0;fo(i, 1, n) if(d[i].x != d[i - 1].x) xx[++tot].fi = d[i].x, xx[tot].se = i, prex[d[i].x] = tot;fo(i, 1, n) if(p[i].y != p[i - 1].y) yy[++zoz].fi = p[i].y, yy[zoz].se = i, prey[p[i].y] = zoz;if(zoz < tot){swap(tot, zoz);fo(i, 1, max(tot, zoz)) swap(xx[i], yy[i]);fo(i, 1, n) swap(d[i].x, p[i].y), swap(d[i].y, p[i].x), swap(prex[i], prey[i]);}xx[tot + 1].se = n + 1;yy[zoz + 1].se = n + 1;fo(i, 1, tot){int z1 = xx[i].se;while(z1 <= xx[i + 1].se - 1){int z2 = lower_bound(p + 1, p + 1 + n, (rmm){d[z1].x, d[z1].y}) - p;int bz = prey[p[z2].y]; z2++;while(z2 <= yy[bz + 1].se - 1){ans1[prex[p[z2].x]] += ans2[prex[p[z2].x]] * 2 + 1, ans2[prex[p[z2].x]]++;z2++;}z1++;}fo(j, i + 1, tot)ans += (ans1[j] - ans2[j]) / 2, ans1[j] = ans2[j] = 0;}printf("%lld\n", ans);return Ratio;}
}
signed main(){return Wisadel::main();}
正解晚上补。
发现根号分治实现也很简单啊。首先还是把点都按列存起来,记录每列的点数。对于点数不大于 \(\sqrt{n}\) 的列,把它上面的所有点按行存起来,然后逐行处理,到每个点暴力跑统计出到每一行的二元组数量,统计答案后记得清除。复杂度 \(\mathcal{O(n\sqrt{n})}\)。
对于点数超过 \(\sqrt{n}\) 的列,更暴力了,直接 \(\mathcal{O(n)}\) 看每个点的贡献,最后统计答案即可,注意不要重复统计。复杂度 \(\mathcal{O(\frac{n^2}{\sqrt{n}})=O(n\sqrt{n})}\)。
因此复杂度是 \(\mathcal{O(n\sqrt{n})}\) 的,不愧是正解,跑得很快。
正解代码
#include<bits/stdc++.h>
#define fo(x, y, z) for(register int (x) = (y); (x) <= (z); (x)++)
#define fu(x, y, z) for(register int (x) = (y); (x) >= (z); (x)--)
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
#define lx ll
inline lx qr()
{char ch = getchar(); lx x = 0, f = 1;for(; ch < '0' || ch > '9'; ch = getchar()) if(ch == '-') f = -1;for(; ch >= '0' && ch <= '9'; ch = getchar()) x = (x << 3) + (x << 1) + (ch ^ 48);return x * f;
}
#undef lx
#define qr qr()
#define fi first
#define se second
#define pii pair<int, int>
#define P_B(x) push_back(x)
#define M_P(x, y) make_pair(x, y)
const int Ratio = 0;
const int N = 2e5 + 5;
const int mod = 998244353;
int n, len;
int cnt[N];
ll ans, now[N];
struct rmm{int x, y;} d[N];
vector<int> vx[N], vy[N];
bool yz[N];
namespace Wisadel
{void Wsolsmall(){fo(i, 1, n) if(cnt[d[i].x] <= len) vy[d[i].y].P_B(d[i].x);fo(i, 1, n) sort(vx[i].begin(), vx[i].end(), greater<int>());fo(j, 1, n){for(int i : vy[j]){vx[i].pop_back();for(int k : vx[i]) now[k]++;}for(int i : vy[j]) for(int k : vx[i])ans += now[k] * (now[k] - 1) / 2, now[k] = 0;}}void Wsolbig(){fo(i, 1, n){if(cnt[i] <= len) continue;fill(yz + 1, yz + 1 + n, 0);fill(now + 1, now + 1 + n, 0);for(int j : vx[i]) yz[j] = 1;fo(ii, 1, n) if(yz[d[ii].y]) now[d[ii].x]++;fo(ii, 1, n) if(cnt[ii] <= len || ii < i)ans += now[ii] * (now[ii] - 1) / 2;}}short main(){freopen("rect.in", "r", stdin), freopen("rect.out", "w", stdout);n = qr; len = sqrt(n);fo(i, 1, n) d[i].x = qr, d[i].y = qr, cnt[d[i].x]++, vx[d[i].x].P_B(d[i].y);Wsolsmall();Wsolbig();printf("%lld\n", ans);return Ratio;}
}
signed main(){return Wisadel::main();}
C. 集合
容斥 + FFT,男蚌。
赛时猜了个结论拿了 10pts。
D. 倒水
期望 + 线段树优化,牛魔。
赛时打了个暴力拿了 24pts。
44pts 做法:期望转概率。设 \(f_{i,j}\) 表示第 \(i\) 个杯子倒水时有 \(k\) 个水的概率。发现当一个杯子往前倒水时之后一定没有操作了,因此对于枚举到的每个杯子分两种情况考虑,一是往前倒水,然后直接统计答案;二是向后转移,只统计自身的答案。转移非常好写:
其中 \(p_i=\frac{f_{i,j}}{n-1}\)。复杂度 \(\mathcal{O(n^3)}\)。前缀优化可以达到 \(\mathcal{O(n^2)}\),可以得到 60pts。
点击查看代码
#include<bits/stdc++.h>
#define fo(x, y, z) for(register int (x) = (y); (x) <= (z); (x)++)
#define fu(x, y, z) for(register int (x) = (y); (x) >= (z); (x)--)
using namespace std;
typedef long long ll;
typedef unsigned long long ull;
#define lx ll
inline lx qr()
{char ch = getchar(); lx x = 0, f = 1;for(; ch < '0' || ch > '9'; ch = getchar()) if(ch == '-') f = -1;for(; ch >= '0' && ch <= '9'; ch = getchar()) x = (x << 3) + (x << 1) + (ch ^ 48);return x * f;
}
#undef lx
#define qr qr()
#define fi first
#define se second
#define pii pair<int, int>
#define P_B(x) push_back(x)
#define M_P(x, y) make_pair(x, y)
const int Ratio = 0;
const int N = 2000 + 5;
const int mod = 998244353;
int n;
int a[N];
ll f[N][N], ans[N];
namespace Wisadel
{ll Wqp(ll x, int y){ll res = 1;while(y){if(y & 1) res = res * x % mod; x = x * x % mod; y >>= 1;}return res;}short main(){freopen("bottle.in", "r", stdin), freopen("bottle.out", "w", stdout);n = qr;fo(i, 1, n) a[i] = qr;ll ny = Wqp(n - 1, mod - 2);f[1][a[1]] = 1;fo(i, 1, n) fo(j, 1, a[i]){ll p = f[i][j] * ny % mod;fo(k, 1, i - 1){int v = min(j, a[k]);ans[i] = (ans[i] + p * (j - v) % mod) % mod;ans[k] = (ans[k] + p * v) % mod;}fo(k, i + 1, n){int v = min(j, a[k]);ans[i] = (ans[i] + p * (j - v) % mod) % mod;f[k][v] = (f[k][v] + p) % mod;}}fo(i, 1, n) printf("%lld\n", ans[i]);return Ratio;}
}
signed main(){return Wisadel::main();}
末
比昨天强点,但不多。
开题一眼三道取模压迫感就来了,因为 T1 看了会不会打就先通读了一遍,然后打 T4,打完打的 T2,结果空间没改 + 取模没改直接嗯挂 52pts。
T1 最后 15min 想到了过程中计算,少了个很大的常数但没有多得分,其实感觉到这再想想就能做出来了,可惜回看得太晚来不及了。
突然想到一场比赛三道 dp,两道计数(
完结撒花~
www 怎么状态越来越差了(